/*
 *	Meta-characters for arguments:
 *
 *		r	register
 *		x	register or one-digit constant
 *		l	label (A-Z)
 *		d	direction (L/R/B)
 *		a	azimuth (N/E/W/S)
 */

// syntax	display			name
I("-",		"",			nop	)	// XXX: Must be first
I("Arxx",	"r ← x + x",		add	)
I("Cd",		"CALL d",		call	)
I("Drxx",	"r ← x / x",		div	)
I("Exx",	"IF x=x",		ifeq	)
I("Fa",		"FACE a",		face	)
I("Gl",		"GOTO l",		goto	)
I("H",		"HALT",			halt	)
I("I",		"INIT",			init	)	// XXX: Hack in program::resolve_labels()
I("J",		"JUMP",			jump	)
I("K",		"RETURN",		return	)
I("Ll",		"LABEL l",		label	)	// XXX: Hack in program::resolve_labels()
I("Mrxx",	"r ← x * x",		mul	)
I("Nrx",	"r ← ARRAY(x)",		array	)
I("Prxx",	"r ← 10x + x",		append	)
I("QLrxx",	"r ← x « x",		shl	)
I("QRrxx",	"r ← x » x",		shr	)
I("Rrrx",	"r ← r[x]",		read	)
I("Srxx",	"r ← x - x",		sub	)
I("Td",		"TURN d",		turn	)
I("Uxx",	"IF x≠x",		ifne	)
I("Vrx",	"r ← x",		let	)
I("Wrxx",	"r[x] ← x",		write	)
I("Xxx",	"IF x < x",		iflt	)
I("Yxx",	"IF x > x",		ifgt	)
I("Zrxx",	"r ← x % x",		mod	)
